#include "Messenger_i.h"
#include <ace/streams.h>

int main(int argc, char* argv[])
{
	try {
		//Initialize the ORB.
		CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);

		//Get a reference to the RootPOA.
		CORBA::Object_var obj = orb->resolve_initial_references("RootPOA");
		PortableServer::POA_var poa = PortableServer::POA::_narrow(obj.in());


		// Activate the POAManager.
		PortableServer::POAManager_var mgr = poa->the_POAManager();
		mgr->activate();

		// Create a servant.
		Messenger_i servant;

		// Register the servant with the RootPOA, obtain its object
		// reference, stringify it, and write it to a file.
		PortableServer::ObjectId_var oid = poa->activate_object(&servant);
		obj = poa->id_to_reference(oid.in());
		CORBA::String_var str = orb->object_to_string(obj.in());
		ofstream iorFile("Messenger.ior");
		iorFile << str.in() << endl;
		iorFile.close();
		cout << "IOR written to file Messenger.ior" << endl;

		// Accept requests from clients.
		orb->run();
		orb->destroy();

		return 0;
	}
	catch (CORBA::Exception& ex) {
		cerr << "CORBA exception: " << ex << endl;
	}
	return 1;
}
